]> git.proxmox.com Git - mirror_lxc.git/blob - templates/lxc-plamo.in
plamo: Support LXC_CACHE_PATH
[mirror_lxc.git] / templates / lxc-plamo.in
1 #!/bin/bash -eu
2
3 #
4 # template script for generating Plamo Linux container for LXC
5 #
6
7 #
8 # lxc: linux Container library
9
10 # Authors:
11 # KATOH Yasufumi <karma@jazz.email.ne.jp>
12 # TAMUKI Shoichi <tamuki@linet.gr.jp>
13
14 # This library is free software; you can redistribute it and/or
15 # modify it under the terms of the GNU Lesser General Public
16 # License as published by the Free Software Foundation; either
17 # version 2.1 of the License, or (at your option) any later version.
18
19 # This library is distributed in the hope that it will be useful,
20 # but WITHOUT ANY WARRANTY; without even the implied warranty of
21 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
22 # Lesser General Public License for more details.
23
24 # You should have received a copy of the GNU Lesser General Public
25 # License along with this library; if not, write to the Free Software
26 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
27
28 # ref. https://github.com/Ponce/lxc-slackware/blob/master/lxc-slackware
29 # lxc-ubuntu script
30
31 # Detect use under userns (unsupported)
32 for arg in "$@"; do
33 [ "$arg" = "--" ] && break
34 if [ "$arg" = "--mapped-uid" -o "$arg" = "--mapped-gid" ]; then
35 echo "This template can't be used for unprivileged containers." 1>&2
36 echo "You may want to try the \"download\" template instead." 1>&2
37 exit 1
38 fi
39 done
40
41 # Make sure the usual locations are in PATH
42 export PATH=$PATH:/usr/sbin:/usr/bin:/sbin:/bin
43
44 [ -r /etc/default/lxc ] && . /etc/default/lxc
45
46 DLSCHEME=${DLSCHEME:-"http"}
47 MIRRORSRV=${MIRRORSRV:-"www.ring.gr.jp"}
48 MIRRORPATH=${MIRRORPATH:-"/pub/linux/Plamo"}
49 CATEGORIES=${CATEGORIES-"00_base 01_minimum"}
50 EXTRACTGRS=${EXTRACTGRS-""}
51 IGNOREPKGS=${IGNOREPKGS-"grub kernel lilo linux_firmware microcode_ctl
52 cpufreqd cpufrequtils gpm"}
53 ADDONPKGS=${ADDONPKGS-"`echo contrib/Hamradio/{morse,qrq}`"}
54
55 download_plamo() {
56 # check the mini plamo was not already downloaded
57 if ! mkdir -p $ptcache ; then
58 echo "Failed to create '$ptcache' directory."
59 return 1
60 fi
61 # download a mini plamo into a cache
62 echo "Downloading Plamo-$release minimal..."
63 cd $ptcache
64 case $DLSCHEME in http) depth=2 ;; ftp) depth=3 ;; esac
65 rej=${IGNOREPKGS%% *} ; [ -n "$rej" ] && rej="$rej-*"
66 if [ `echo $IGNOREPKGS | wc -w` -gt 1 ] ; then
67 for p in ${IGNOREPKGS#* } ; do rej="$rej,$p-*" ; done
68 fi
69 for i in $CATEGORIES ; do
70 wget -nv -e robots=off -r -l $depth -nd -A .tgz,.txz -R "$rej" \
71 -I $MIRRORPATH/Plamo-$release/$arch/plamo/$i \
72 -X $MIRRORPATH/Plamo-$release/$arch/plamo/$i/old \
73 $DLSCHEME://$MIRRORSRV$MIRRORPATH/Plamo-$release/$arch/plamo/$i
74 if [ $? -ne 0 ] ; then
75 echo "Failed to download the rootfs, aborting."
76 return 1
77 fi
78 done
79 for i in $EXTRACTGRS ; do
80 wget -nv -e robots=off -r -l $depth -nd -A .tgz,.txz -R "$rej" \
81 -I $MIRRORPATH/Plamo-$release/$arch/contrib/$i \
82 -X $MIRRORPATH/Plamo-$release/$arch/contrib/$i/old \
83 $DLSCHEME://$MIRRORSRV$MIRRORPATH/Plamo-$release/$arch/contrib/$i
84 if [ $? -ne 0 ] ; then
85 echo "Failed to download the rootfs, aborting."
86 return 1
87 fi
88 done
89 for p in $ADDONPKGS ; do
90 wget -nv -e robots=off -r -l $depth -nd -A "`basename $p`-*" \
91 -I $MIRRORPATH/Plamo-$release/$arch/`dirname $p` \
92 -X $MIRRORPATH/Plamo-$release/$arch/`dirname $p`/old \
93 $DLSCHEME://$MIRRORSRV$MIRRORPATH/Plamo-$release/$arch/`dirname $p`
94 if [ $? -ne 0 ] ; then
95 echo "Failed to download the rootfs, aborting."
96 return 1
97 fi
98 done
99 mv $ptcache $dlcache
100 echo "Download complete."
101 return 0
102 }
103
104 copy_plamo() {
105 # make a local copy of the mini plamo
106 echo "Copying $rtcache to $rootfs..."
107 mkdir -p $rootfs
108 find $rtcache -mindepth 1 -maxdepth 1 -exec cp -a {} $rootfs \; || return 1
109 return 0
110 }
111
112 install_plamo() {
113 mkdir -p @LOCALSTATEDIR@/lock/subsys
114 (
115 if ! flock -n 9 ; then
116 echo "Cache repository is busy."
117 return 1
118 fi
119 echo "Checking cache download in $dlcache..."
120 if [ ! -d $dlcache ] ; then
121 if ! download_plamo ; then
122 echo "Failed to download plamo $release base packages."
123 return 1
124 fi
125 fi
126 # install "installpkg" command temporarily with static linked tar
127 # command into the lxc cache directory to keep the original uid/
128 # gid of files/directories.
129 echo "Installing 'installpkg' command into $dlcache/sbin..."
130 ( cd $dlcache ; tar xpJf hdsetup-*.txz ; rm -rf tmp usr var )
131 sed -i "/ldconfig/!s@/sbin@$dlcache&@g" $dlcache/sbin/installpkg*
132 PATH=$dlcache/sbin:$PATH
133 echo "Installing packages to $rtcache..."
134 if [ ! -d $rtcache ] ; then
135 mkdir -p $rtcache
136 for p in `ls -cr $dlcache/*.t?z` ; do
137 installpkg -root $rtcache -priority ADD $p
138 done
139 fi
140 echo "Copy $rtcache to $rootfs..."
141 if ! copy_plamo ; then
142 echo "Failed to copy rootfs."
143 return 1
144 fi
145 return 0
146 ) 9> @LOCALSTATEDIR@/lock/subsys/lxc-plamo
147 }
148
149 configure_plamo() {
150 # suppress log level output for udev
151 sed -i 's/="err"/=0/' $rootfs/etc/udev/udev.conf
152 # /etc/fstab
153 cat <<- "EOF" > $rootfs/etc/fstab
154 none /proc proc defaults 0 0
155 none /sys sysfs defaults 0 0
156 none /dev tmpfs defaults 0 0
157 none /tmp tmpfs defaults 0 0
158 none /dev/pts devpts gid=5,mode=620 0 0
159 none /proc/bus/usb usbfs noauto 0 0
160 none /var/lib/nfs/rpc_pipefs rpc_pipefs defaults 0 0
161 EOF
162 # /etc/inittab
163 cat <<- "EOF" | patch $rootfs/etc/inittab
164 32,33c32,33
165 < # What to do when power fails (shutdown to single user).
166 < pf::powerfail:/sbin/shutdown -f +5 "THE POWER IS FAILING"
167 ---
168 > # What to do when power fails (shutdown).
169 > pf::powerfail:/sbin/shutdown -h +0 "THE POWER IS FAILING"
170 47a48
171 > 1:1235:respawn:/sbin/agetty 38400 console
172 52,53d52
173 < c5:1235:respawn:/sbin/agetty 38400 tty5 linux
174 < c6:12345:respawn:/sbin/agetty 38400 tty6 linux
175 EOF
176 # set the hostname
177 echo "$name" > $rootfs/etc/HOSTNAME
178 # set minimal hosts
179 echo "127.0.0.1 localhost $name" > $rootfs/etc/hosts
180 # configure the network using the dhcp
181 echo "DHCP" > $rootfs/var/run/inet1-scheme
182 # localtime (JST)
183 ln -s ../usr/share/zoneinfo/Asia/Tokyo $rootfs/etc/localtime
184 # disable pam_loginuid.so in /etc/pam.d/login (for libvirt's lxc driver)
185 sed -i '/pam_loginuid/s/^/#/' $rootfs/etc/pam.d/login
186 # glibc configure
187 mv $rootfs/etc/ld.so.conf{.new,}
188 chroot $rootfs ldconfig
189 # root password
190 echo "Setting root password to 'root'..."
191 echo "root:root" | chroot $rootfs chpasswd
192 echo "Please change root password!"
193 ed - $rootfs/etc/rc.d/rc.S <<- "EOF"
194 /^mount -w -n -t proc/;/^mkdir \/dev\/shm/-1d
195 /^mknod \/dev\/null/;/^# Clean \/etc\/mtab/-2d
196 /^# copy the rules/;/^# Set the hostname/-1d
197 /^# Check the integrity/;/^# Clean up temporary/-1d
198 w
199 EOF
200 # /etc/rc.d/rc.M
201 ed - $rootfs/etc/rc.d/rc.M <<- "EOF"
202 /^# Screen blanks/;/^# Initialize ip6tables/-1d
203 /^# Initialize sysctl/;/^echo "Starting services/-1d
204 /^sync/;/^# All done/-1d
205 w
206 EOF
207 # /etc/rc.d/rc.inet1.tradnet
208 head -n-93 $rootfs/sbin/netconfig.tradnet > /tmp/netconfig.rconly
209 cat <<- EOF >> /tmp/netconfig.rconly
210 PCMCIA=n
211 RC=$rootfs/etc/rc.d/rc.inet1.tradnet
212 IFCONFIG=sbin/ifconfig
213 ROUTE=sbin/route
214 INET1SCHEME=var/run/inet1-scheme
215 IPADDR=127.0.0.1
216 NETWORK=127.0.0.0
217 DHCPCD=usr/sbin/dhclient
218 LOOPBACK=y
219 make_config_file
220 EOF
221 rm -f $rootfs/etc/rc.d/rc.inet1.tradnet
222 sh /tmp/netconfig.rconly
223 rm -f /tmp/netconfig.rconly
224 sed -i '/cmdline/s/if/& false \&\&/' $rootfs/etc/rc.d/rc.inet1.tradnet
225 return 0
226 }
227
228 copy_configuration() {
229 ret=0
230 cat <<- EOF >> $path/config || let ret++
231 lxc.utsname = $name
232 lxc.arch = $arch
233 EOF
234 if [ -f "@LXCTEMPLATECONFIG@/plamo.common.conf" ] ; then
235 cat <<- "EOF" >> $path/config || let ret++
236
237 lxc.include = @LXCTEMPLATECONFIG@/plamo.common.conf
238 EOF
239 fi
240 if [ $ret -ne 0 ] ; then
241 echo "Failed to add configuration."
242 return 1
243 fi
244 return 0
245 }
246
247 post_process() {
248 # nothing do in Plamo Linux
249 true
250 }
251
252 do_bindhome() {
253 # bind-mount the user's path into the container's /home
254 h=`getent passwd $bindhome | cut -d: -f6`
255 mkdir -p $rootfs/$h
256 echo "lxc.mount.entry = $h $rootfs/$h none bind 0 0" >> $path/config
257 # copy /etc/passwd, /etc/shadow, and /etc/group entries into container
258 if ! pwd=`getent passwd $bindhome` ; then
259 echo "Warning: failed to copy password entry for $bindhome."
260 else
261 echo $pwd >> $rootfs/etc/passwd
262 fi
263 echo `getent shadow $bindhome` >> $rootfs/etc/shadow
264 }
265
266 cleanup() {
267 [ -d $dlcache -a -d $rtcache ] || return 0
268 # lock, so we won't purge while someone is creating a repository
269 (
270 if ! flock -n 9 ; then
271 echo "Cache repository is busy."
272 return 1
273 fi
274 echo "Purging the download cache..."
275 rm -rf --one-file-system $dlcache $rtcache || return 1
276 echo "Done."
277 return 0
278 ) 9> @LOCALSTATEDIR@/lock/subsys/lxc-plamo
279 }
280
281 usage() {
282 cat <<- EOF
283 $prog [-h|--help] -p|--path=<path> -n|--name=<name> --rootfs=<rootfs>
284 [-c|--clean] [-r|--release=<release>] [-a|--arch=<arch>]
285 [-b|--bindhome=<user>]
286 release: $release
287 arch: x86 or x86_64: defaults to host arch
288 bindhome: bind <user>'s home into the container
289 EOF
290 }
291
292 prog=`basename $0`
293 path="" ; name="" ; rootfs=""
294 clean=0
295 release=${release:-5.x}
296 arch=`uname -m | sed 's/i.86/x86/'` ; hostarch=$arch
297 bindhome=""
298 sopts=hp:n:cr:a:b:
299 lopts=help,path:,name:,rootfs:,clean,release:,arch:,bindhome:
300 if ! options=`getopt -o $sopts -l $lopts -- "$@"` ; then
301 usage
302 exit 1
303 fi
304 eval set -- "$options"
305 while true ; do
306 case "$1" in
307 -h|--help) usage && exit 0 ;;
308 -p|--path) path=$2 ; shift 2 ;;
309 -n|--name) name=$2 ; shift 2 ;;
310 --rootfs) rootfs=$2 ; shift 2 ;;
311 -c|--clean) clean=1 ; shift 1 ;;
312 -r|--release) release=$2 ; shift 2 ;;
313 -a|--arch) arch=$2 ; shift 2 ;;
314 -b|--bindhome) bindhome=$2 ; shift 2 ;;
315 --) shift 1 ; break ;;
316 *) break ;;
317 esac
318 done
319 if [ $clean -eq 1 -a -z "$path" ] ; then
320 cleanup || exit 1
321 exit 0
322 fi
323 if [ $hostarch == "x86" -a $arch == "x86_64" ] ; then
324 echo "Can't create x86_64 container on x86."
325 exit 1
326 fi
327 if [ -z "$path" ] ; then
328 echo "'path' parameter is required."
329 exit 1
330 fi
331 if [ -z "$name" ] ; then
332 echo "'name' parameter is required."
333 exit 1
334 fi
335 if [ `id -u` -ne 0 ] ; then
336 echo "This script should be run as 'root'."
337 exit 1
338 fi
339 cache="${LXC_CACHE_PATH:-@LOCALSTATEDIR@/cache/lxc}"
340 ptcache=$cache/partial-${prog##*-}-$release-$arch
341 dlcache=$cache/cache-${prog##*-}-$release-$arch
342 rtcache=$cache/rootfs-${prog##*-}-$release-$arch
343 if [ -z "$rootfs" ] ; then
344 if grep -q "^lxc.rootfs" $path/config ; then
345 rootfs=`awk -F= '/^lxc.rootfs =/{ print $2 }' $path/config`
346 else
347 rootfs=$path/rootfs
348 fi
349 fi
350 if ! install_plamo ; then
351 echo "Failed to install plamo $release."
352 exit 1
353 fi
354 if ! configure_plamo ; then
355 echo "Failed to configure plamo $release for a container."
356 exit 1
357 fi
358 if ! copy_configuration ; then
359 echo "Failed to write configuration file."
360 exit 1
361 fi
362 post_process
363 if [ -n "$bindhome" ] ; then
364 do_bindhome
365 fi
366 if [ $clean -eq 1 ] ; then
367 cleanup || exit 1
368 exit 0
369 fi